## Documentation for Graphql

### Libraries

clients
- Fetch API
- graphql-request - https://github.com/prisma-labs/graphql-request
- graphql-upload - https://github.com/jaydenseric/graphql-upload
- urql - https://github.com/FormidableLabs/urql
- apollo-client - https://github.com/apollographql/apollo-client (bloated)

- server
  - https://github.com/graphql/express-graphql
- subscriptions (client side & server side)
  - https://github.com/enisdenjo/graphql-ws

### Benchmarks

https://github.com/benawad/node-graphql-benchmarks

### Considerations

- jwt tokens and refresh tokens
- file uploads
- cache
- resolver problems
- https://www.freecodecamp.org/news/five-common-problems-in-graphql-apps-and-how-to-fix-them-ac74d37a293c/
- https://blog.logrocket.com/5-reasons-you-shouldnt-be-using-graphql-61c7846e7ed3/
- https://shammelburg.medium.com/subscriptions-with-graphql-dfa8279af050
- https://httptoolkit.tech/blog/simple-graphql-server-without-apollo
- https://blog.logrocket.com/why-i-finally-switched-to-urql-from-apollo-client/
- https://dev.to/remorses/you-don-t-need-apollo-to-use-graphql-in-react-1277
- https://the-guild.dev/blog/subscriptions-and-live-queries-real-time-with-graphql (quite good)
