// for UI usage only...
module.exports = {
  db: 'knex',
  conn: 'knex1',
  name: 'authors',
  create: true,
  update: true,
  delete: 0,
  import: true,
  export: true,
  multiSelect: true, // multiple selection
  cols: {
    id: { // primary key column, _id for mongodb (can cause error in mongodb)
      label: 'ID',
      auto: 'pk',
      hide: true,
      add: 'readonly',
      edit: 'readonly'
    },
    name: {
      label: 'Name',
      type: 'string',
      filter: true,
      default: '',
      ui: {
        tag: 'input'
      },
    },
    avatar: {
      label: 'Avatar',
      type: 'string',
      filter: true,
      default: '',
      ui: {
        tag: 'input',
        // attrs: { type: 'file' }
      },
    },
    created_at: {
      label: 'Created At',
      auto: 'ts', // autogenerated field... user = user id, ts = timestamp, pk = autogenerated primary key
      hide: true,
      add: 'hide',
      edit: 'readonly'
    },
    updated_at: {
      label: 'Updated At',
      auto: 'ts',
      hide: true,
      add: 'hide',
      edit: 'readonly'
    }
  },

  // generated values
  pk: '',
  multiKey: [],
  required: [],
  auto: [],
  nonAuto: []
  // {id: 1, name: 'book1', categoryId: 1, rating: 5, yearPublished: '2004', created_at: mkDt() },
}
